//Source file: D:\\Lara\\New Folder\\treeaddin\\TGui.java

package simpleJavaApp;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import com.rational.java2rei.*;

public class TGui extends JFrame 
{
   private final QuitHandler theQuitHandler= new QuitHandler();
   private final TMain theTMain;

   private IRoseApplication theApplication= null;
   private final OpenHandler theOpenHandler = new OpenHandler();
   private final Container cp = getContentPane();
   private final JSplitPane theSplitPane = new JSplitPane ();
   private JScrollPane theScrollPane1 ;
   private JScrollPane theScrollPane2;
   private final JTextArea theTextArea = new JTextArea("");
   private final JMenuItem theOpenRoseNewFile = new JMenuItem ("Open Rose");
   private final JMenuItem thePropertyMenu = new JMenuItem ("Display Properties of selected Items");

   private final JMenuItem theCloseRose = new JMenuItem ("Close Rose");
   private final JMenuItem theCloseIntrospector = new JMenuItem ("Exit");
   private final JMenuBar theJMenuBar = new JMenuBar();
   private final JMenu theFileMenu = new JMenu("File");
   private TRoseHandler theRoseHandler;
   private TRoseReflection theRoseRef;
  
   public TGui(TMain aTMain) 
   {
    super("Introspector");
    theTMain = aTMain;
    
    setupMenuBar();
    setupEventHandlers();

    theRoseHandler = new TRoseHandler();
    theRoseRef = new TRoseReflection();
    layoutComponents();
    
    this.pack();
    this.setVisible(true);    
   
   }
   
   public void dispose() 
   {
    super.dispose();
    System.exit(0);    
   }
   
  
   public IRoseApplication getTheApplication() 
   {
      return theApplication;    
   }
   
  
   public void setTheApplication(IRoseApplication theApp) 
   {
      theApplication = theApp;    
   }
   
  
   void setupMenuBar() 
   {
    theFileMenu.add(theOpenRoseNewFile);
    theCloseRose.setEnabled(false);
    theFileMenu.add(thePropertyMenu);
    thePropertyMenu.setEnabled(false);
    theFileMenu.add(theCloseRose);
    theFileMenu.add(theCloseIntrospector);
    theJMenuBar.add(theFileMenu);
    setJMenuBar(theJMenuBar);
   }
   

   void setupEventHandlers() 
   {
    this.addWindowListener(theQuitHandler);
    theCloseRose.addActionListener(theQuitHandler);
    theCloseIntrospector.addActionListener(theQuitHandler);
    theOpenRoseNewFile.addActionListener(theOpenHandler);
    thePropertyMenu.addActionListener(theOpenHandler);
   }
   
   
   void layoutComponents() 
   {
    theScrollPane1 = new JScrollPane(theRoseHandler.getRoseItemProperties());
    if(theApplication != null)  
    	theRoseRef.updateText(theApplication);
    theScrollPane2 = new JScrollPane(theRoseRef.getRoseItemReflection());
	theSplitPane.setLeftComponent(theScrollPane1);
	theSplitPane.setRightComponent(theScrollPane2);
        theSplitPane.setDividerLocation(0.5);
    cp.add(theSplitPane,BorderLayout.CENTER);
	
    
   }

 
   
   class QuitHandler extends WindowAdapter implements ActionListener{
     public void windowClosing(WindowEvent windowevent) 
     {    
          dispose();
      }
   
     public void actionPerformed(java.awt.event.ActionEvent p1) { 
        if (theApplication!=null) { 

            theApplication.exit(); 
            theApplication.setVisible(false);
            theApplication.releaseDispatches(); 
            theApplication=null;
            theOpenRoseNewFile.setEnabled(true);
            theCloseRose.setEnabled(false);
	    thePropertyMenu.setEnabled(false);
    }
    String cmd = p1.getActionCommand();
    if(cmd.equals("Exit")){
        dispose();
    }
   
   }
   }
   
   class OpenHandler implements ActionListener {

   public void actionPerformed(ActionEvent arg0) 
   {
    String cmd = arg0.getActionCommand();
    if (cmd.equals("Open Rose")){
        theApplication = new RoseApplication();
        theApplication.setVisible(true);
        theOpenRoseNewFile.setEnabled(false);
        theCloseRose.setEnabled(true);
	thePropertyMenu.setEnabled(true);
	
    }

    if (cmd.equals("Display Properties of selected Items"))
	{


	  cp.remove(theScrollPane1);
	  theRoseHandler = new TRoseHandler(theApplication);
	  layoutComponents();
	  cp.validate();
	}
 
    
   }
   }

}
