

package simpleJavaApp;

import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;
import java.awt.event.*;
import com.rational.java2rei.*;

//We build our own TableModel in order to make it
//not editable -- it is editable by default
class MyTableModel extends AbstractTableModel{

   Object[] columnNames = 
   {"Item Name","Tool","Property Name","Property Type","Property Value"};

   Object [][] rowData;
 
    public MyTableModel(Object[][] theData){
	rowData = theData;
    }

    public String getColumnName(int col) { 
        return columnNames[col].toString(); 
    }

    public int getRowCount() { return rowData.length; }

    public int getColumnCount() { return columnNames.length; }

    public Object getValueAt(int row, int col) { 
        return rowData[row][col]; 
    }

    public boolean isCellEditable(int row, int col)
        { return false; }

    public void setValueAt(Object value, int row, int col) {
        rowData[row][col] = value;
	fireTableCellUpdated(row, col);
    }
	

}

public class TRoseHandler 
{
  
   TableModel MyTableModel;
   JTable RoseItemProperties;

   IRosePropertyCollection thePropertyCollection;

   IRoseProperty theProperty;
   IRoseItem theRoseItem;
   IRoseItemCollection theItemCollection;
   IRoseDiagram theDiagram;
   IRoseDiagramCollection theDiagramCollection;

   	
 
   public TRoseHandler() 
	{
		Object [][] emptyData = {{"...","...","...","...","..."},{"...","...","...","...","..."}};

                TableModel theTableModel = new MyTableModel(emptyData);
		RoseItemProperties = new JTable(theTableModel);
	}

   public TRoseHandler(IRoseApplication theApplication) 
   {
	int total = 0;
	int idx = 0;

	theItemCollection = theApplication.getCurrentModel().getSelectedItems();
	theDiagramCollection = theApplication.getCurrentModel().getSelectedDiagrams();



	//Count properties from Items
	for (short j = 1 ; j<= theItemCollection.getCount();j++){
	  theRoseItem = theItemCollection.getAt(j);	
	  thePropertyCollection = theRoseItem.getAllProperties();
	  total+=thePropertyCollection.getCount();
	}
	//Count properties from diagrams
	for (short j = 1 ; j<= theDiagramCollection.getCount();j++){
	  theDiagram = theDiagramCollection.getAt(j);	
	  thePropertyCollection = theDiagram.getAllProperties();
	  total+=thePropertyCollection.getCount();
	}

        Object[][] propertyData = new Object[total][5] ;

	//fill properties from items
	for (short j = 1 ; j<= theItemCollection.getCount();j++){

	theRoseItem = theItemCollection.getAt(j);
	
	thePropertyCollection = theRoseItem.getAllProperties();



	for (short i =1 ; i<= thePropertyCollection.getCount(); i++){
		theProperty = thePropertyCollection.getAt(i);
	        propertyData[idx][0]=theRoseItem.getQualifiedName();
		propertyData[idx][1]=theProperty.getToolName();
		propertyData[idx][2]=theProperty.getName();		
		propertyData[idx][3]=theProperty.getType();		
		propertyData[idx][4]=theProperty.getValue();
		idx++;

	}


	}
        //fill properties from diagrams 
        for (short j = 1 ; j<= theDiagramCollection.getCount();j++){

	theDiagram = theDiagramCollection.getAt(j);
	
	thePropertyCollection = theDiagram.getAllProperties();



	for (short i =1 ; i<= thePropertyCollection.getCount(); i++){
		theProperty = thePropertyCollection.getAt(i);
	        propertyData[idx][0]=theDiagram.getQualifiedName();
		propertyData[idx][1]=theProperty.getToolName();
		propertyData[idx][2]=theProperty.getName();		
		propertyData[idx][3]=theProperty.getType();		
		propertyData[idx][4]=theProperty.getValue();
		idx++;

	}


	}
  	RoseItemProperties = null;
        TableModel theTableModel = new MyTableModel(propertyData);
	RoseItemProperties = new JTable(theTableModel);
			 
   }
   

   JTable getRoseItemProperties(){
	return RoseItemProperties;
   } 

}
